#-*- coding:utf-8 -*-

import operator

from django.core.management.base import BaseCommand
from django.db.models import Q, Max, Count
from django.utils.encoding import smart_str

from dictionary.models import Lemma


class Command(BaseCommand):
    args = 'none'
    help = 'Get flat and big frames count from ready and checked frames.'

    def handle(self, **options):
      frames_count()

def frames_count():
  q_status_list = []
  q_status_list.append(Q(status__status=u'gotowe'))
  q_status_list.append(Q(status__status=u'sprawdzone'))

  lemmas = Lemma.objects.filter(old=False).filter(reduce(operator.or_, q_status_list))
  
  big_frames = 0
  flat_frames = 0
  for lemma in lemmas.all():
      print smart_str(lemma.entry)
      big_frames += lemma.frames.count()
      print lemma.frames.count()
      for frame in lemma.frames.all():
          max_args = frame.positions.annotate(num_args=Count('arguments')).aggregate(Max('num_args'))['num_args__max']
          flat_frames += max_args
      
  big_frames = float(big_frames)
  flat_frames = float(flat_frames)
  
  print 'big_frames: ' + str(big_frames)
  print 'flat_frames: ' + str(flat_frames)
  print str(flat_frames/big_frames)
    
